/* **********************************************************************************
*
* Copyright (c) Microsoft Corporation. All rights reserved.
*
* This source code is subject to terms and conditions of the Shared Source License
* for DSL Editor PowerToy. A copy of the license can be found in the License.htm file
* at the root of this distribution. If you can not locate the Shared Source License
* for DSL Editor PowerToy, please obtain a copy from: http://www.codeplex.com/dsltreegrideditor/Project/License.aspx.
* By using this source code in any fashion, you are agreeing to be bound by
* the terms of the Shared Source License for DSL Editor PowerToy.
*
* You must not remove this notice, or any other, from this software.
*
* **********************************************************************************/
using System;
using System.Collections.Generic;
using System.Text;

namespace DslEditorPowerToy.ComponentModel.Design
{
    [AttributeUsage(AttributeTargets.Property, Inherited = false, AllowMultiple = false)]
    public class SolutionItemPickerFilterAttribute : Attribute
    {
        string _filter = string.Empty;
        SolutionItemType _type = SolutionItemType.Custom;

        #region Public Properties
        /// <summary>
        /// Returns the file filter
        /// </summary>
        public string Filter
        {
            get
            {
                return this._filter;
            }
            set
            {
                this._filter = value;
            }
        }
        /// <summary>
        /// Returns the types of solution items
        /// </summary>
        public SolutionItemType ItemType
        {
            get
            {
                return this._type;
            }
            set
            {
                this._type = value;
            }
        }
        #endregion
    }
}