/* **********************************************************************************
*
* Copyright (c) Microsoft Corporation. All rights reserved.
*
* This source code is subject to terms and conditions of the Shared Source License
* for DSL Editor PowerToy. A copy of the license can be found in the License.htm file
* at the root of this distribution. If you can not locate the Shared Source License
* for DSL Editor PowerToy, please obtain a copy from: http://www.codeplex.com/dsltreegrideditor/Project/License.aspx.
* By using this source code in any fashion, you are agreeing to be bound by
* the terms of the Shared Source License for DSL Editor PowerToy.
*
* You must not remove this notice, or any other, from this software.
*
* **********************************************************************************/
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DslEditorPowerToy.Controls
{
    /// <summary>
    /// Describes the configuration of a hosted editor
    /// </summary>
    public interface IHostedEditorDefinition
    {
        /// <summary>
        /// Unique identifier of editor
        /// </summary>
        Guid Id
        {
            get;
        }
        /// <summary>
        /// The caption of the editor
        /// </summary>
        string Caption
        {
            get;
        }
        /// <summary>
        /// The image for the editor
        /// </summary>
        Bitmap Image
        {
            get;
        }
        /// <summary>
        /// The control providing the editor
        /// </summary>
        Control Control
        {
            get;
        }
    }
}
