/* **********************************************************************************
*
* Copyright (c) Microsoft Corporation. All rights reserved.
*
* This source code is subject to terms and conditions of the Shared Source License
* for DSL Editor PowerToy. A copy of the license can be found in the License.htm file
* at the root of this distribution. If you can not locate the Shared Source License
* for DSL Editor PowerToy, please obtain a copy from: http://www.codeplex.com/dsltreegrideditor/Project/License.aspx.
* By using this source code in any fashion, you are agreeing to be bound by
* the terms of the Shared Source License for DSL Editor PowerToy.
*
* You must not remove this notice, or any other, from this software.
*
* **********************************************************************************/
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace DslEditorPowerToy.Controls
{
    /// <summary>
    /// Interface to query for selected components
    /// </summary>
    public interface ISelectionProvider
    {
        /// <summary>
        /// Gets the selected components
        /// </summary>
        /// <returns></returns>
        ICollection GetSelectedComponents();

        /// <summary>
        /// Gets the primary selected component
        /// </summary>
        object PrimarySelection
        {
            get;
        }
        /// <summary>
        /// Gets the count of selected components
        /// </summary>
        int SelectionCount
        {
            get;
        }
    }
}
