/* **********************************************************************************
*
* Copyright (c) Microsoft Corporation. All rights reserved.
*
* This source code is subject to terms and conditions of the Shared Source License
* for DSL Editor PowerToy. A copy of the license can be found in the License.htm file
* at the root of this distribution. If you can not locate the Shared Source License
* for DSL Editor PowerToy, please obtain a copy from: http://www.codeplex.com/dsltreegrideditor/Project/License.aspx.
* By using this source code in any fashion, you are agreeing to be bound by
* the terms of the Shared Source License for DSL Editor PowerToy.
*
* You must not remove this notice, or any other, from this software.
*
* **********************************************************************************/
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;

namespace DslEditorPowerToy.Controls.Editors.Special.DomainModelTreeGrid.Data
{
    internal class DomainElementCollection<T> : ReadOnlyCollection<T> where T : IDomainElement
    {
        #region Constructors
        public DomainElementCollection(IList<T> list)
            : base(list)
        {
        }
        #endregion

        #region Public Methods
        /// <summary>
        /// Converts all items in collection
        /// </summary>
        /// <returns></returns>
        public DomainElementCollection<IDomainElement> ConvertAll()
        {
            List<IDomainElement> elements = new List<IDomainElement>();
            foreach (T item in this.Items)
                elements.Add(item);
            return new DomainElementCollection<IDomainElement>(elements);
        }
        #endregion
    }
}