/* **********************************************************************************
*
* Copyright (c) Microsoft Corporation. All rights reserved.
*
* This source code is subject to terms and conditions of the Shared Source License
* for DSL Editor PowerToy. A copy of the license can be found in the License.htm file
* at the root of this distribution. If you can not locate the Shared Source License
* for DSL Editor PowerToy, please obtain a copy from: http://www.codeplex.com/dsltreegrideditor/Project/License.aspx.
* By using this source code in any fashion, you are agreeing to be bound by
* the terms of the Shared Source License for DSL Editor PowerToy.
*
* You must not remove this notice, or any other, from this software.
*
* **********************************************************************************/
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;

using Microsoft.VisualStudio.Modeling;

namespace DslEditorPowerToy.Controls.Editors.Special.DomainModelTreeGrid.Data
{
    internal interface IDomainRelationship : IDomainElement, IDomainElementContainer
    {
        /// <summary>
        /// Gets the domain model root element
        /// </summary>
        IDomainModel DomainModel
        {
            get;
        }
        /// <summary>
        /// Gets the parent domain class for this relationship
        /// </summary>
        IDomainClass ParentClass
        {
            get;
        }
        /// <summary>
        /// Gets a list of the child domain classes
        /// </summary>
        DomainElementCollection<IDomainClass> ChildClasses
        {
            get;
        }
        /// <summary>
        /// Gets the type of the classes
        /// </summary>
        Type ClassType
        {
            get;
        }
    }
}
