/* **********************************************************************************
*
* Copyright (c) Microsoft Corporation. All rights reserved.
*
* This source code is subject to terms and conditions of the Shared Source License
* for DSL Editor PowerToy. A copy of the license can be found in the License.htm file
* at the root of this distribution. If you can not locate the Shared Source License
* for DSL Editor PowerToy, please obtain a copy from: http://www.codeplex.com/dsltreegrideditor/Project/License.aspx.
* By using this source code in any fashion, you are agreeing to be bound by
* the terms of the Shared Source License for DSL Editor PowerToy.
*
* You must not remove this notice, or any other, from this software.
*
* **********************************************************************************/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using VSTrid = Microsoft.VisualStudio.VirtualTreeGrid;

using DslEditorPowerToy.Controls.VirtualTreeGrid;

using DslEditorPowerToy.Controls.Editors.Special.DomainModelTreeGrid;
using DslEditorPowerToy.Controls.Editors.Special.DomainModelTreeGrid.Data;

namespace DslEditorPowerToy.Controls.Editors.Special.DomainModelTreeGrid
{
    internal partial class DomainModelTreeGridHost : VirtualTreeGridHostBase
    {
        #region Constructors
        public DomainModelTreeGridHost()
            : base(new DomainModelTreeGridControl())
        {
            InitializeComponent();

            this.TreeGridControl.StandardCheckBoxes = true;
            this.TreeGridControl.Columns.Add(new VSTrid.VirtualTreeColumnHeader(ControlResources.ColumnHeaderText2, 0.2F));
            this.TreeGridControl.Columns.Add(new VSTrid.VirtualTreeColumnHeader(ControlResources.ColumnHeaderText3, 0.2F));
            this.TreeGridControl.Columns.Add(new VSTrid.VirtualTreeColumnHeader(ControlResources.ColumnHeaderText4, 50, 
                VSTrid.VirtualTreeColumnHeaderStyles.AlignCenter));
        }
        #endregion

        #region Protected Properties
        protected override string NoSelectionText
        {
            get
            {
                return ControlResources.NoSelectionText;
            }
        }
        #endregion
    }
}
