/* **********************************************************************************
*
* Copyright (c) Microsoft Corporation. All rights reserved.
*
* This source code is subject to terms and conditions of the Shared Source License
* for DSL Editor PowerToy. A copy of the license can be found in the License.htm file
* at the root of this distribution. If you can not locate the Shared Source License
* for DSL Editor PowerToy, please obtain a copy from: http://www.codeplex.com/dsltreegrideditor/Project/License.aspx.
* By using this source code in any fashion, you are agreeing to be bound by
* the terms of the Shared Source License for DSL Editor PowerToy.
*
* You must not remove this notice, or any other, from this software.
*
* **********************************************************************************/
using System;
using System.Collections.Generic;
using System.ComponentModel.Design;
using System.Text;

namespace DslEditorPowerToy.Controls.Languages
{
    /// <summary>
    /// An interface for editor host containers to manage interacts with control.
    /// </summary>
    public interface IEditorHostContainer
    {
        /// <summary>
        /// Gets the current editor
        /// </summary>
        IHostedEditorDefinition CurrentEditor
        {
            get;
        }
        /// <summary>
        /// Get the current navigation style
        /// </summary>
        NavigationOrientationStyle NavigationStyle
        {
            get;
            set;
        }
        /// <summary>
        /// Activates the specified editor
        /// </summary>
        /// <param name="editorId"></param>
        void ActivateEditor(Guid editorId);
        /// <summary>
        /// Gets a list of editors
        /// </summary>
        List<IHostedEditorDefinition> Editors
        {
            get;
        }
    }
}
