/* **********************************************************************************
*
* Copyright (c) Microsoft Corporation. All rights reserved.
*
* This source code is subject to terms and conditions of the Shared Source License
* for DSL Editor PowerToy. A copy of the license can be found in the License.htm file
* at the root of this distribution. If you can not locate the Shared Source License
* for DSL Editor PowerToy, please obtain a copy from: http://www.codeplex.com/dsltreegrideditor/Project/License.aspx.
* By using this source code in any fashion, you are agreeing to be bound by
* the terms of the Shared Source License for DSL Editor PowerToy.
*
* You must not remove this notice, or any other, from this software.
*
* **********************************************************************************/
using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace DslEditorPowerToy.Controls.VirtualTreeGrid.Branches
{
    [AttributeUsage(AttributeTargets.Field | AttributeTargets.Property, AllowMultiple=false, Inherited=true)]
    internal class BranchColumnAttribute : Attribute
    {
        #region Constructors
        public BranchColumnAttribute() : base()
        {
        }
        #endregion
    }
    [AttributeUsage(AttributeTargets.Field | AttributeTargets.Property, AllowMultiple=false, Inherited=true)]
    internal class ColumnHeaderAttribute : Attribute
    {
        private string _text = string.Empty;
        private int _order = int.MinValue;

        #region Constructors
        public ColumnHeaderAttribute(int order)
            : this(string.Empty, order)
        {
        }
        public ColumnHeaderAttribute(string text, int order)
            : base()
        {
            this._text = text;
            this._order = order;
        }
        #endregion

        #region Public Properties
        public string Text
        {
            get
            {
                return this._text;
            }
            set
            {
                this._text = value;
            }
        }
        public int Order
        {
            get
            {
                return this._order;
            }
            set
            {
                this._order = value;
            }
        }
        #endregion
    }
}
