/* **********************************************************************************
*
* Copyright (c) Microsoft Corporation. All rights reserved.
*
* This source code is subject to terms and conditions of the Shared Source License
* for DSL Editor PowerToy. A copy of the license can be found in the License.htm file
* at the root of this distribution. If you can not locate the Shared Source License
* for DSL Editor PowerToy, please obtain a copy from: http://www.codeplex.com/dsltreegrideditor/Project/License.aspx.
* By using this source code in any fashion, you are agreeing to be bound by
* the terms of the Shared Source License for DSL Editor PowerToy.
*
* You must not remove this notice, or any other, from this software.
*
* **********************************************************************************/
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using VSTrid = Microsoft.VisualStudio.VirtualTreeGrid;

namespace DslEditorPowerToy.Controls.VirtualTreeGrid
{
    public class ColumnCollection : List<VSTrid.VirtualTreeColumnHeader>
    {
        #region Constructors
        public ColumnCollection() : base()
        {
        }
        #endregion

        #region Public Methods
        /// <summary>
        /// Returns array of columnheaders for TreeGrid
        /// </summary>
        /// <returns></returns>
        internal VSTrid.VirtualTreeColumnHeader[] GetColumnHeaders()
        {
            VSTrid.VirtualTreeColumnHeader[] columnHeaders = new VSTrid.VirtualTreeColumnHeader[this.Count];
            int index = 0;
            foreach (VSTrid.VirtualTreeColumnHeader column in this)
                columnHeaders[index++] = column;

            return columnHeaders;
        }
        #endregion
    }
}
