using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace DslEditorPowerToy.Controls.VirtualTreeGrid
{
    public class SelectionChangedEventArgs : EventArgs
    {
        private object _selectedDataItem = null;
        private string _propertyName = null;

        #region Constructors
        public SelectionChangedEventArgs(object selectedDataItem, string propertyName)
        {
            this._selectedDataItem = selectedDataItem;
            this._propertyName = propertyName;
        }
        #endregion

        #region Public Properties
        public object SelectedDataItem
        {
            get
            {
                return this._selectedDataItem;
            }
        }
        public string PropertyName
        {
            get
            {
                return this._propertyName;
            }
        }
        #endregion
    }
    internal class DataItemChangedEventArgs : EventArgs
    {
        private object _dataItem = null;
        private string _propertyName = null;
        private object _propertyValue = null;

        #region Constructors
        public DataItemChangedEventArgs(object dataItem, string propertyName,
            object propertyValue)
        {
            this._dataItem = dataItem;
            this._propertyName = propertyName;
            this._propertyValue = propertyValue;
        }
        #endregion

        #region Public Properties
        public object DataItem
        {
            get
            {
                return this._dataItem;
            }
        }
        public string PropertyName
        {
            get
            {
                return this._propertyName;
            }
        }
        public object CurrentValue
        {
            get
            {
                return this._propertyValue;
            }
        }
        #endregion
    }
    internal class LabelEditChangedEventArgs : EventArgs
    {
        private Control _editControl = null;

        #region Constructors
        public LabelEditChangedEventArgs(Control editControl)
            : base()
        {
            this._editControl = editControl;
        }
        #endregion

        #region Public Properties
        public Control EditControl
        {
            get
            {
                return this._editControl;
            }
        }
        #endregion
    }
}
