/* **********************************************************************************
*
* Copyright (c) Microsoft Corporation. All rights reserved.
*
* This source code is subject to terms and conditions of the Shared Source License
* for DSL Editor PowerToy. A copy of the license can be found in the License.htm file
* at the root of this distribution. If you can not locate the Shared Source License
* for DSL Editor PowerToy, please obtain a copy from: http://www.codeplex.com/dsltreegrideditor/Project/License.aspx.
* By using this source code in any fashion, you are agreeing to be bound by
* the terms of the Shared Source License for DSL Editor PowerToy.
*
* You must not remove this notice, or any other, from this software.
*
* **********************************************************************************/
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace DslEditorPowerToy.Controls.VirtualTreeGrid
{
    internal interface IKeyNavigationBranch
    {
        /// <summary>
        /// Gives the navigationBranch a chance to handle key press events
        /// </summary>
        ProcessKeyResult ProcessKeyPress(int row, int column, char keyPressed, Keys modifiers);
        /// <summary>
        /// Gives the navigationBranch a chance to handle key down events
        /// </summary>
        ProcessKeyResult ProcessKeyDown(int row, int column, KeyEventArgs e);
        /// <summary>
        /// Detemrines if the current row is the new placeholder row for adding new items
        /// </summary>
        bool IsRowNewPlaceholderRow(int row);
    }
}
