/* **********************************************************************************
*
* Copyright (c) Microsoft Corporation. All rights reserved.
*
* This source code is subject to terms and conditions of the Shared Source License
* for DSL Editor PowerToy. A copy of the license can be found in the License.htm file
* at the root of this distribution. If you can not locate the Shared Source License
* for DSL Editor PowerToy, please obtain a copy from: http://www.codeplex.com/dsltreegrideditor/Project/License.aspx.
* By using this source code in any fashion, you are agreeing to be bound by
* the terms of the Shared Source License for DSL Editor PowerToy.
*
* You must not remove this notice, or any other, from this software.
*
* **********************************************************************************/
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Text;

using DslEditorPowerToy.VisualStudio;

namespace DslEditorPowerToy.Recipes.ValueProviders
{
    /// <summary>
    /// Returns an empty string
    /// </summary>
    public class EmptyStringValueProvider : ValueProviderBase
    {
        #region Constructors
        public EmptyStringValueProvider()
            : base()
        {
        }
        #endregion

        #region Public Methods
        public override bool OnBeginRecipe(object currentValue, out object newValue)
        {
            newValue = string.Empty;
            return true;
        }
        public override bool OnBeforeActions(object currentValue, out object newValue)
        {
            return OnBeginRecipe(currentValue, out newValue);
        }
        #endregion
    }
}
